from rrdtool import update as rrd_update
import serial
from struct import *
from datetime import datetime
import time
import sqlite3
import subprocess
#**************************************
def graph():
	import sys
	import rrdtool
	print "Creating graph"

	ret = rrdtool.graph( "/var/www/all.png", "--vertical-label=Watts", "-w 800","-h 480",
	 "DEF:pin=power.rrd:powerin:AVERAGE",
	 "DEF:hwt=power.rrd:hotwater:AVERAGE",
	 "DEF:htp=power.rrd:heatpump:AVERAGE",
	 "DEF:wkp=power.rrd:workshop:AVERAGE",
	 "DEF:hss=power.rrd:houseuse:AVERAGE",
	 "LINE:pin#00FF00:Total Power",
	 "LINE:hwt#0000FF:Hot Water",
	 "LINE:htp#FF0000:Heat Pump",
	 "LINE:wkp#00FFFF:Workshop",
	 "LINE:hss#FF00FF:House use\\r")
	if ret:
		print rrdtool.error()

	ret = rrdtool.graph( "/var/www/total.png", "--vertical-label=Watts", "-w 800","-h 400",
	 "DEF:pin=power.rrd:powerin:AVERAGE",
	 "LINE:pin#00FF00:Total Power\\r")
	if ret:
		print rrdtool.error()

	ret = rrdtool.graph( "/var/www/hotwater.png", "--vertical-label=Watts", "-w 800","-h 400",
	 "DEF:pin=power.rrd:hotwater:AVERAGE",
	 "LINE:pin#0000FF:Hot water\\r")
	if ret:
		print rrdtool.error()

	ret = rrdtool.graph( "/var/www/heatpump.png", "--vertical-label=Watts", "-w 800","-h 400",
	 "DEF:pin=power.rrd:heatpump:AVERAGE",
	 "LINE:pin#FF0000:Heatpump\\r")
	if ret:
		print rrdtool.error()

	ret = rrdtool.graph( "/var/www/workshop.png", "--vertical-label=Watts", "-w 800","-h 400",
	 "DEF:pin=power.rrd:workshop:AVERAGE",
	 "LINE:pin#00FFFF:Workshop\\r")
	if ret:
		print rrdtool.error()

	ret = rrdtool.graph( "/var/www/houseuse.png", "--vertical-label=Watts", "-w 800","-h 400",
	 "DEF:pin=power.rrd:houseuse:AVERAGE",
	 "LINE:pin#FF00FF:House use\\r")
	if ret:
		print rrdtool.error()

	ret = rrdtool.graph("/var/www/metering.png", "--vertical-label=Watt/hours","-w 800","-h 400",
	 "DEF:pin=power.rrd:pt_total:AVERAGE",
	 "DEF:pth=power.rrd:pt_house:AVERAGE",
 	 "DEF:pthw=power.rrd:pt_hotwater:AVERAGE", 
	 "DEF:pthp=power.rrd:pt_heatpump:AVERAGE",
	 "DEF:ptws=power.rrd:pt_workshop:AVERAGE",
	 "LINE:pin#0000FF:Total",
	 "LINE:pth#00FF00:House",
	 "LINE:pthw#FF0000:Hotwater",
	 "LINE:pthp#00FFFF:Heatpump",
	 "LINE:ptws#FF00FF:Workshop\\r")
	if ret:
		print rrdtool.error()
	return()	
#**************************************
def get_date_time():
        day = localtime.tm_mday
        mon = localtime.tm_mon
        year= localtime.tm_year
        hour= localtime.tm_hour
        min = localtime.tm_min
        sec = localtime.tm_sec

        sday = str(day)
        if day <10:
                 sday="0"+sday

        smon = str(mon)
        if mon <10:
                 smon="0"+smon

        shour = str(hour)
        if hour <10:
                 shour="0"+shour

        smin = str(min)
        if min <10:
                 smin="0"+smin

        ssec = str(sec)
        if sec <10:
                 ssec="0"+ssec

        daydate = sday+"/"+smon+"/"+str(year)
        daytime = shour+":"+smin+":"+ssec

	return (daydate,daytime)
#******************************************
def disp(channel,ch,name):
	n1,n2,n3,i1,i2,p1,p2,state = unpack('cccccccc',channel)
#	name = n1+n2+n3
	id = ord(i2)*256+ord(i1)
	power = ord(p2)*256+ord(p1)
	state = ord(state)
	
	conn = sqlite3.connect("House.db")
	cursor = conn.cursor()

	daydate,daytime = get_date_time()

	sql = 'INSERT INTO power VALUES ('+'"'+daydate+'","'+daytime+'",'+str(ch)+',"'+name+'",'+str(power)+','+str(state)+','+str(id)+')'
	cursor.execute(sql)
	conn.commit()
	return (power,state)
#**************************************
	

port = serial.Serial("/dev/ttyUSB0",baudrate=9600,timeout=1.0)
pt_total = 0.0
pt_house = 0.0
pt_hotwater = 0.0
pt_heatpump = 0.0
pt_workshop = 0.0

ypt_total = 0.0
ypt_house = 0.0
ypt_hotwater = 0.0
ypt_heatpump = 0.0
ypt_workshop = 0.0

power2 = 0.0
power3 = 0.0
power4 = 0.0
power5 = 0.0

while(1):
        localtime = time.localtime(time.time())
        while(localtime.tm_sec != 0 and localtime.tm_sec != 10 and localtime.tm_sec != 20 and localtime.tm_sec != 30 and localtime.tm_sec != 40 and localtime.tm_sec != 50):
                localtime = time.localtime(time.time())

	port.write(chr(0xaa)+chr(0x02)+chr(0x00)+chr(0xad))
	chan1 = port.read(8)
	if len(chan1) == 8:
		print "Recieved data at ",datetime.now()		
	else:
		print "Serial timeout at ",datetime.now()
	
	chan2 = port.read(8)
	if len(chan2) == 8:
		power2,state2 = disp(chan2,2,'Supply')
		
	chan3 = port.read(8)
	if len(chan3) == 8:
		power3,state3 = disp(chan3,3,'Hotwater')

	chan4 = port.read(8)
	if len(chan4) == 8:
		power4,state4 = disp(chan4,4,'Heatpump')

	chan5 = port.read(8)
	if len(chan5) == 8:
		power5,state5 = disp(chan5,5,'Workshop')

	chan6 = port.read(8)
	chan7 = port.read(8)
	chan8 = port.read(8)
	chan9 = port.read(8)
	chan10= port.read(8)
	chan11= port.read(8)
	chan12= port.read(8)
	chan13= port.read(8)
	chan14= port.read(8)
	chan15= port.read(8)
	chan16= port.read(8)
	checksum = port.read(1)

	powerin  = power2
	hotwater = power3
	heatpump = power4
	workshop = power5
	houseuse = power2-(power3 + power4 + power5)

	min = localtime.tm_min
	sec = localtime.tm_sec
	hour = localtime.tm_hour
	daydate,daytime = get_date_time()

        cost = 0.000246

	log = open("/var/www/log.txt","w")
	log.write('Total,house,hotwater,heatpump,workshop\n')
        log.write('Current power use       %s, %s, %s, %s, %s\n' %(str(powerin),str(houseuse),str(hotwater),str(heatpump),str(workshop)))
        log.write('Current power total     %s, %s, %s, %s, %s\n' %(str(pt_total),str(pt_house),str(pt_hotwater),str(pt_heatpump),str(pt_workshop)))
        log.write('Current Cost total      %s, %s, %s, %s, %s\n' %(str(pt_total * cost),str(pt_house * cost),str(pt_hotwater*cost),str(pt_heatpump * cost),str(pt_workshop*cost)))
	if pt_total != 0:
	       	log.write('Percent of total          %s, %s, %s, %s\n'   %(str((pt_house/pt_total)*100),str((pt_hotwater/pt_total)*100),str((pt_heatpump/pt_total)*100),str((pt_workshop/pt_total)*100)))
        log.write('Yesterdays power total  %s, %s, %s, %s, %s\n' %(str(ypt_total),str(ypt_house),str(ypt_hotwater),str(ypt_heatpump),str(ypt_workshop)))
        log.write('Yesterdays cost total   %s, %s, %s, %s, %s\n' %(str(ypt_total*cost),str(ypt_house*cost),str(ypt_hotwater*cost),str(ypt_heatpump*cost),str(ypt_workshop*cost)))
 	log.write('Last updated at %s %s\n' %(daydate,daytime))	
	log.close()

        print('Total,house,hotwater,heatpump,workshop')
        print('Current power use       %s, %s, %s, %s, %s' %(str(powerin),str(houseuse),str(hotwater),str(heatpump),str(workshop)))
        print('Current power total     %s, %s, %s, %s, %s' %(str(pt_total),str(pt_house),str(pt_hotwater),str(pt_heatpump),str(pt_workshop)))
        print('Current Cost total      %s, %s, %s, %s, %s' %(str(pt_total * cost),str(pt_house * cost),str(pt_hotwater*cost),str(pt_heatpump * cost),str(pt_workshop*cost)))
        if pt_total != 0:
                print('Percent of total         100, %s, %s, %s, %s'   %(str((pt_house/pt_total)*100),str((pt_hotwater/pt_total)*100),str((pt_heatpump/pt_total)*100),str((pt_workshop/pt_total)*100)))
        print('Yesterdays power total  %s, %s, %s, %s, %s' %(str(ypt_total),str(ypt_house),str(ypt_hotwater),str(ypt_heatpump),str(ypt_workshop)))
	print('Yesterdays cost total   %s, %s, %s, %s, %s' %(str(ypt_total*cost),str(ypt_house*cost),str(ypt_hotwater*cost),str(ypt_heatpump*cost),str(ypt_workshop*cost)))
 
        print('Last updated at %s %s\n' %(daydate,daytime))


	if (hour == 0 and min == 0  and sec == 0):
                ypt_total = pt_total		#save yesterdays usage
                ypt_house = pt_house
                ypt_hotwater = pt_hotwater
                ypt_heatpump = pt_heatpump
                ypt_workshop = pt_workshop

		pt_total = 0.0			#reset todays usage
		pt_house = 0.0
		pt_hotwater = 0.0
		pt_heatpump = 0.0
		pt_workshop = 0.0
	else:
		pt_total = pt_total + (powerin / 360.0)
		pt_house = pt_house + (houseuse / 360.0)
		pt_hotwater = pt_hotwater + (hotwater / 360.0)
		pt_heatpump = pt_heatpump + (heatpump / 360.0)
		pt_workshop = pt_workshop + (workshop / 360.0)

	ret = rrd_update('power.rrd','N:%s:%s:%s:%s:%s:%s:%s:%s:%s:%s' %(powerin, hotwater, heatpump, workshop, houseuse,pt_total,pt_house,pt_hotwater,pt_heatpump,pt_workshop));
	if ret:
		print rrdtool.error()

	if (min == 00 or min == 10 or min == 20 or min == 30 or min == 40 or min == 50) and sec == 00:
		graph()
	else:
		time.sleep(2.0)
port.close()


